#  This file is part of Boatswain.
#
#      Boatswain<https://github.com/theboatswain> is free software: you can redistribute it and/or modify
#      it under the terms of the GNU General Public License as published by
#      the Free Software Foundation, either version 3 of the License, or
#      (at your option) any later version.
#
#      Boatswain is distributed in the hope that it will be useful,
#      but WITHOUT ANY WARRANTY; without even the implied warranty of
#      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#      GNU General Public License for more details.
#
#      You should have received a copy of the GNU General Public License
#      along with Boatswain.  If not, see <https://www.gnu.org/licenses/>.
#
#
import os
import sys


def isMac():
    return sys.platform.startswith('darwin')


def isWin():
    return sys.platform.startswith('win')


def isLinux():
    return sys.platform.startswith('linux')


def getArchitecture():
    if sys.maxsize > 0x100000000:
        return 'x64'
    return 'x32'


def getListOfFiles(root_dir):
    """
    For the given path, get the List of all files in the directory tree in Relative form
    @rtype: set
    """
    file_set = set()

    for dir_, _, files in os.walk(root_dir):
        for file_name in files:
            rel_dir = os.path.relpath(dir_, root_dir)
            rel_file = os.path.join(rel_dir, file_name)
            file_set.add(rel_file)

    return file_set
